# Author renyupeng
# coding=utf-8
# @Time    : 2021/12/20 11:18 上午
# @Site    :
# @File    : NewKuaiShouAllMaterialFourD.py.py
# @Software: PyCharm
# @contact: renyupeng@c-top.com.cn
# @Tel 1501435553
import datetime
from urllib import parse
import pandas as pd
import smtplib
from email.mime.text import MIMEText
from email.mime.multipart import MIMEMultipart
from sqlalchemy import create_engine


class NewKuaiShouAllMaterialFourD:
    def __init__(self):
        self.OuterStr = "mysql+pymysql://%s:%s@%s:%d/%s" % (
            "hcst", parse.quote_plus("hcst@2024"), "192.168.0.101", 3390, "application")
        self.OuterConn = create_engine(self.OuterStr,
                                       pool_size=10,
                                       max_overflow=5,
                                       pool_timeout=10,
                                       pool_recycle=3600)
        self.stat_date = (datetime.date.today() + datetime.timedelta(-1)).strftime("%Y%m%d")

    def handler(self):
        sql = """SELECT (CASE WHEN t2.company_name IS NOT NULL THEN t2.company_name ELSE '-' END)              AS '公司',
       ifnull(t2.project_name, '-')                                                                             AS '项目',
       ifnull(t2.signature, '-')                                                                                AS '素材标识',
       (CASE
            WHEN t3.material_innovate = 1 THEN '非创新素材'
            WHEN t3.material_innovate = 2 THEN '创新素材'
            ELSE '-' END)                                                                                       AS '是否创新素材',
       ifnull(t1.frast_cost_time, '-')                                                                               AS '上线时间',
       ifnull(t2.channel_name, '-')                                                                             AS '渠道',
       sum(t2.charge)                                                                                           AS '消耗',
       ifnull(t2.clip_name, '-')                                                                                AS '剪辑',
       ifnull(t2.shot_name, '-')                                                                                AS '拍摄',
       ifnull(t2.plan_name, '-')                                                                                AS '编导',
       ifnull(t2.leader_name, '-')                                                                              AS '负责人',
       ifnull(t2.video_name, '-')                                                                               AS '素材名称',
       ifnull(t2.photo_url, '-')                                                                                AS '素材'
from (select signature,frast_cost_time
      from application.material_farst_cost_time
      where frast_cost_time >= date_format(date_sub({stat_date}, INTERVAL 13 DAY), '%%Y%%m%%d') and frast_cost_time<={stat_date}) t1
         left join
     (select *
      from application.kuaishou_material_video_report_daily_dw
      where stat_date >= date_format(date_sub({stat_date}, INTERVAL 13 DAY), '%%Y%%m%%d')) t2
     on t1.signature = t2.signature
left join `jeecg-boot`.ctop_material_info t3
on t1.signature=t3.code
where t2.signature is not null
group by t1.signature;""".format(stat_date=self.stat_date)
        print(sql)
        path = """/data/excel/NewKuaiShouAllMaterialFourD_{stat_date}.xls""".format(stat_date=self.stat_date)
        print(path)
        pd.read_sql(sql, self.OuterConn).to_excel(path, index=False, engine='openpyxl')
        my_sender = 'renyupeng@c-top.com.cn'  # 发件人邮箱账号
        my_pass = 'fcyJKkHUyPo6Zztw'  # 发件人邮箱授权码 / 腾讯企业邮箱请使用登陆密码
        recipients = ['wanglei@c-top.com.cn',
                      'shiyuke@s-hcst.com',
                      'lihuan@c-top.com.cn']  # 收件人邮箱账号
        # content = "Please check the attachment. "
        msg = MIMEMultipart()
        # [发件人的邮箱昵称、发件人邮箱账号], 昵称随便
        msg['From'] = my_sender
        # [收件人邮箱昵称、收件人邮箱账号], 昵称随便
        msg['To'] = ",".join(recipients)
        # 邮件的主题，也就是邮件的标题
        msg['Subject'] = "快手-近14天上线素材消耗全明细"

        att1 = MIMEText(
            open(path, 'rb').read(), 'base64', 'utf-8')
        att1["Content-Type"] = 'application/octet-stream'
        att1["Content-Disposition"] = 'attachment; filename="NewKuaiShouAllMaterialFourD.xls"'
        msg.attach(att1)
        server = smtplib.SMTP_SSL("smtp.exmail.qq.com", port=465)
        server.login(my_sender, my_pass)
        try:
            server.sendmail(my_sender, recipients, msg.as_string())
            print("发送成功")
        except Exception as e:
            print("发送失败", e)


if __name__ == '__main__':
    NewKuaiShouAllMaterialFourD().handler()
