# Author renyupeng
# coding=utf-8
# @Time    : 2021/12/20 11:18 上午
# @Site    :
# @File    : send_material_report_weekly.py.py
# @Software: PyCharm
# @contact: renyupeng@c-top.com.cn
# @Tel 1501435553
import datetime
from urllib import parse
import pandas as pd
import smtplib
from email.mime.text import MIMEText
from email.mime.multipart import MIMEMultipart
from sqlalchemy import create_engine


class kwai_caiwu:
    def __init__(self):
        self.OuterStr = "mysql+pymysql://%s:%s@%s:%d/%s" % (
            "hcst", parse.quote_plus("hcst@2024"), "192.168.0.101", 3390, "application")
        self.OuterConn = create_engine(self.OuterStr,
                                       pool_size=10,
                                       max_overflow=5,
                                       pool_timeout=10,
                                       pool_recycle=3600)
        self.stat_date = (datetime.date.today() + datetime.timedelta(-1)).strftime("%Y%m%d")

    def handler(self):
        sql = """
        SELECT
      date_format(date_sub(NOW() , INTERVAL 1 MONTH), '%%Y%%m') as '年月',
      t1.company_name            as '公司',
       t1.project_name            as '项目',
       ifnull(t6.realname ,'-')            as '上级',
       ifnull(t5.realname,'-')                as '运营',
       CONCAT(t1.account_id, '_') as '账户id',
       t1.account_name            as '账户名称',
       sum(t1.charge)               as '消耗'
from application.kuaishou_account_report_daily_dw t1
         LEFT JOIN `jeecg-boot`.sys_user t5
                   ON t1.user_id = t5.id
       left join `jeecg-boot`.sys_user t6
on t5.leader_id=t6.id
WHERE t1.stat_date >= date_format(date_sub(NOW() , INTERVAL 1 MONTH), '%%Y%%m01')
  AND t1.stat_date <=  date_format(date_sub(DATE_FORMAT(NOW() , '%%Y-%%m-01'),interval 1 day),'%%Y%%m%%d')
  AND t1.charge > 0
GROUP BY t1.account_id;

        """
        print(sql)
        path = """/data/excel/快手数据_{stat_date}.xls""".format(stat_date=self.stat_date)
        print(path)
        pd.read_sql(sql, self.OuterConn).to_excel(path, index=False, engine='openpyxl')
        my_sender = 'renyupeng@c-top.com.cn'  # 发件人邮箱账号
        my_pass = 'fcyJKkHUyPo6Zztw'  # 发件人邮箱授权码 / 腾讯企业邮箱请使用登陆密码
        recipients = ['caiwu@c-top.com.cn', 'yumengmeng@c-top.com.cn']  # 收件人邮箱账号
        # content = "Please check the attachment. "
        msg = MIMEMultipart()
        # [发件人的邮箱昵称、发件人邮箱账号], 昵称随便
        msg['From'] = my_sender
        # [收件人邮箱昵称、收件人邮箱账号], 昵称随便
        msg['To'] = ",".join(recipients)
        # 邮件的主题，也就是邮件的标题
        msg['Subject'] = "快手数据_{stat_date}".format(stat_date=self.stat_date)

        att1 = MIMEText(
            open(path, 'rb').read(), 'base64', 'utf-8')
        att1["Content-Type"] = 'application/octet-stream'
        att1["Content-Disposition"] = 'attachment; filename="kuaishou.xls"'
        msg.attach(att1)
        server = smtplib.SMTP_SSL("smtp.exmail.qq.com", port=465)
        server.login(my_sender, my_pass)
        try:
            server.sendmail(my_sender, recipients, msg.as_string())
            print("发送成功")
        except Exception as e:
            print("发送失败", e)


if __name__ == '__main__':
    kwai_caiwu().handler()
